/*
   ui/window.h
   This file is part of the Osirion project and is distributed under
   the terms of the GNU General Public License version 2
*/

#ifndef __INCLUDED_UI_WINDOW_H__
#define __INCLUDED_UI_WINDOW_H__

#include "ui/widget.h"

namespace ui
{

/// a user interface window
class Window : public Widget
{

public:
	Window(Widget *parent = 0);
	~Window();

	/// set the label of the previous window
	void set_previous(Window *previous);

	/// clear the label of the previous window
	void clear_previous();

	/// show the window
	/**show() sets focus on the window and all of its parents
	 */
	virtual void show();

	inline const std::string &previous() const {
		return window_previous;
	}

protected:
	virtual void draw_border();

	std::string	window_previous;
};

}

#endif // __INCLUDED_UI_WINDOW_H__
